#!/usr/bin/perl
#
# Copyright (c) 2007, Diomidis Spinellis
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Diomidis Spinellis nor the names of its
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

if ($#ARGV == -1) {
	print STDERR "Usage $0: filename.aux [input file] ...\n";
	exit 1;
}
open(IN, $fname = shift @ARGV) || die "Unable to open $fname: $!\n";
while (<IN>) {
	$name{$1} = $2 if (/\\bibcite\{([^}]+)\}\{([^}]+)\}/);
}

while(<>) {
	while (/\\cite\{([^}]*)\}/) {
		$keys = $1;
		@keys = split(/\,/, $keys);
		undef $names;
		for $k (@keys) {
			$names .= ',' if (defined($names));
			print STDERR "Undefined key [$k]\n" unless (defined($name{$k}));
			$names .= $name{$k};
		}
		s/\\cite\{([^}]*)\}/[$names]/;
	}
	print;
}
